--[[
    
***************************************************************
Two player Local Co-op Open Beta [Hunger for Your Hunger]

Created by: chromiumboy

Thanks to @kiopho for provide me with a background for the new 
player inventories!

I'd like to give a special thanks to my closed beta testers, 
especially @sirmentlegen and @gorleo!

Also a shoutout to @tehMugwump for Test Tools, which was great 
for testing this mod (and it also taught me how to get a 
character selection screen running :D)

***************************************************************

]]

-- GLOBALS list
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local TECH = GLOBAL.TECH
TECH.UNACCESSABLE = {}
TECH.UNACCESSABLE.SCIENCE = 999
TECH.UNACCESSABLE.MAGIC = 0
TECH.UNACCESSABLE.ANCIENT = 0


-- Declare mod prefabs
PrefabFiles = {
	
}


Assets = {
	-- Inventory background								
	Asset("IMAGE", "scripts/images/inv_bg.tex"),		
	Asset("ATLAS", "scripts/images/inv_bg.xml"),	

	-- Character select screen 
	Asset("IMAGE", "images/selectscreen_portraits.tex"),
	Asset("ATLAS", "images/selectscreen_portraits.xml"),
	Asset("IMAGE", "scripts/images/biobox.tex"),
		Asset("ATLAS", "scripts/images/biobox.xml"),
	Asset("IMAGE", "bigportraits/wilson.tex"),
		Asset("ATLAS", "bigportraits/wilson.xml"),
	Asset("IMAGE", "bigportraits/wx78.tex"),
		Asset("ATLAS", "bigportraits/wx78.xml"),
	Asset("IMAGE", "bigportraits/wendy.tex"),
		Asset("ATLAS", "bigportraits/wendy.xml"),
	Asset("IMAGE", "bigportraits/wickerbottom.tex"),
		Asset("ATLAS", "bigportraits/wickerbottom.xml"),
	Asset("IMAGE", "bigportraits/willow.tex"),
		Asset("ATLAS", "bigportraits/willow.xml"),
	Asset("IMAGE", "bigportraits/wolfgang.tex"),
		Asset("ATLAS", "bigportraits/wolfgang.xml"),
	Asset("IMAGE", "bigportraits/wes.tex"),
		Asset("ATLAS", "bigportraits/wes.xml"),
	Asset("IMAGE", "bigportraits/woodie.tex"),
		Asset("ATLAS", "bigportraits/woodie.xml"),
	Asset("IMAGE", "bigportraits/locked.tex"),
		Asset("ATLAS", "bigportraits/locked.xml"),
	Asset("ANIM", "anim/portrait_frame.zip"),
	Asset("ANIM", "anim/scroll_arrow.zip"),

	-- Woodie 
	Asset("ANIM", "anim/woodie.zip"),
	Asset("SOUND", "sound/woodie.fsb"),
    Asset("ANIM", "anim/werebeaver_build.zip"),
    Asset("ANIM", "anim/werebeaver_basic.zip"),
    Asset("ANIM", "anim/player_woodie.zip"),
    Asset("ATLAS", "images/woodie.xml"),
    Asset("IMAGE", "images/woodie.tex"),
    Asset("IMAGE", "images/colour_cubes/beaver_vision_cc.tex"),
	
	-- Waxwell
	Asset("ANIM", "anim/waxwell.zip"),
	Asset("SOUND", "sound/maxwell.fsb"),   
	
	-- Wolfgang
	Asset("ANIM", "anim/wolfgang.zip"),
    Asset("ANIM", "anim/wolfgang_skinny.zip"),
    Asset("ANIM", "anim/wolfgang_mighty.zip"),
    Asset("ANIM", "anim/player_wolfgang.zip"),
	Asset("SOUND", "sound/wolfgang.fsb"),
	
	-- Lucy
	Asset("ANIM", "anim/lucy_axe.zip"),
    Asset("ANIM", "anim/swap_lucy_axe.zip"),
	
	-- Lighter
	Asset("ANIM", "anim/lighter.zip"),
	Asset("ANIM", "anim/swap_lighter.zip"),
	
	-- Balloons
	Asset("ANIM", "anim/balloons_empty.zip"),
	
	-- Abigail's flower
	Asset("ANIM", "anim/abigail_flower.zip"),
	
	-- Revived image
	Asset("IMAGE", "scripts/images/revived.tex"),
		Asset("ATLAS", "scripts/images/revived.xml"),
}


-- Define keypad key codes
GLOBAL.KEY_KP_0 = 256
GLOBAL.KEY_KP_1 = 257
GLOBAL.KEY_KP_2 = 258
GLOBAL.KEY_KP_3 = 259
GLOBAL.KEY_KP_4 = 260
GLOBAL.KEY_KP_5 = 261
GLOBAL.KEY_KP_6 = 262
GLOBAL.KEY_KP_7 = 263
GLOBAL.KEY_KP_8 = 264
GLOBAL.KEY_KP_9 = 265
GLOBAL.KEY_KP_ENTER = 13


-- Import prefab list
GLOBAL.require("prefablist")

for k,file in ipairs(GLOBAL.PREFABFILES) do 
	-- Alter backpack files
	if file == "backpack" or file == "piggyback" or file == "krampus_sack" then
		AddPrefabPostInit(file, function(inst) 
			inst:RemoveComponent("equippable") 
			inst:RemoveComponent("inventoryitem") 
			inst.components.container.widgetpos = Vector3(0,0,0)
			inst.components.container.side_widget = false
		end)	
	end
	
	-- Enable item trading for all items
	AddPrefabPostInit(file, function(inst) 
		if inst.components.inventoryitem and not inst.components.tradable then
			inst:AddComponent("tradable") 
		end
	end)	
end


-- Override the attack action function
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action
function actionpostint(inst)
	ACTIONS.ATTACK.fn = function(act)
		if act.target.components.combat and not (act.target:HasTag("player") and act.doer:HasTag("player")) then
			act.doer.components.combat:SetTarget(act.target)
			return true
		end
	end
end
AddGamePostInit(actionpostint) 


-- Remove backpacks from the crafting menu
GLOBAL.Recipe( "backpack", {}, RECIPETABS.WAR, TECH.UNACCESSABLE, nil, nil, nil, 0)
GLOBAL.Recipe( "piggyback", {}, RECIPETABS.WAR, TECH.UNACCESSABLE, nil, nil, nil, 0)


-- Start up the player monitor
AddSimPostInit(function() GLOBAL.GetWorld():AddComponent("playermonitor") end)
