require "class"
require "screens/pausescreen"
local easing = require "easing"

local trace = function() end

local CLICK_WALK_TIME = .5

local prefabs =
{
    "bishop_charge","trap_teeth_maxwell","shovel"
}

local playercontroller_3 = Class(function(self, inst)
    self.inst = inst
    self.enabled = true
    
    
    self.inputhandlers = {}

    table.insert(self.inputhandlers, TheInput:AddKeyDownHandler(KEY_KP0, function() self:Attack() end))
-----	table.insert(self.inputhandlers, TheInput:AddKeyDownHandler(KEY_L, function() self:AOFF() end))
	table.insert(self.inputhandlers, TheInput:AddKeyDownHandler(KEY_KP_ENTER, function() self:beemine_2() end))
----	table.insert(self.inputhandlers, TheInput:AddKeyDownHandler(KEY_L, function() self:fire() end))



	table.insert(self.inputhandlers, TheInput:AddKeyDownHandler(KEY_Delete, function() self:SpawnPlayer3() end))


    self.inst:StartUpdatingComponent(self)
    self.draggingonground = false
    self.startdragtestpos = nil
    self.startdragtime = nil
end)



function PlayerController_3:SpawnPlayer3()
    self.inst.components.health:DoDelta(-10000)
end




function PlayerController_3:OnRemoveEntity()
    for k,v in pairs(self.inputhandlers) do
        v:Remove()
    end
end


function PlayerController_3:Enable(val)
    self.enabled = val
end




function PlayerController_3:beemine_2()
	local bishop_charge = SpawnPrefab("trap_teeth_maxwell")
    bishop_charge.Transform:SetPosition(self.inst.Transform:GetWorldPosition())
    bishop_charge:AddComponent("health")
    bishop_charge.components.health:SetMaxHealth(30)
    bishop_charge.components.health:StartRegen(-32, 21)
    local light = bishop_charge.entity:AddLight()
    light:SetIntensity(.4)
    light:SetRadius(.4)
    light:SetFalloff(.3)
    light:Enable(true)
    light:SetColour(255/255, 1/255, 1/255)
    self.inst.components.health:DoDelta(-30)
end

function PlayerController_3:Attack()

	if self.enabled and not (self.inst.sg:HasStateTag("working") or self.inst.sg:HasStateTag("doing")) then
		local tool = self.inst.components.inventory_2:GetEquippedItem(EQUIPSLOTS.HANDS)
		
		--combat
		local rad = 3
		local target = FindEntity(self.inst, rad, function(guy) return guy.components.health and not guy.components.health:IsDead() and guy.components.combat and not (guy.components.follower and guy.components.follower.leader == self.inst) end)
		if target then
			local can_attack = target:HasTag("player") or target.components.combat.target == self.inst or can_attack = target:HasTag("abigail")
			if not can_attack then
				trace("   can attack")
				local action = BufferedAction(self.inst, target, ACTIONS.ATTACK)
				self.inst:ClearBufferedAction()
				self.inst.components.locomotor:PushAction(action, true)
				return
			end
		end
	end
end





function PlayerController_3:OnUpdate(dt)
    if self.inst.components.health.currenthealth <= 0 then
	self.inst.components.container:DropEverything()
	end
	
	if not self.inst.sg:HasStateTag("busy") then
		if self.startdragtime then
			local pt = TheInput:GetMouseWorldPos()
			local dst = distsq(pt, Vector3(self.inst.Transform:GetWorldPosition()))
			if dst > 1 then
				local angle = self.inst:GetAngleToPoint(pt)
				--self.inst.components.locomotor:GoToPoint(pt, nil, true)
				self.inst.components.locomotor:RunInDirection(angle)
				self.inst:ClearBufferedAction()
				TheInput:DisableMouseovers()            
			end
			self.directwalking = false
		else
	        
			--WASD walking!
			local xwalk = 0
			local ywalk = 0
			if TheInput:IsKeyDown(KEY_KP8) then
				ywalk = ywalk + 1
			end

			if TheInput:IsKeyDown(KEY_KP5) then
				ywalk = ywalk - 1
			end

			if TheInput:IsKeyDown(KEY_KP4) then
				xwalk = xwalk - 1
			end
	        
			if TheInput:IsKeyDown(KEY_KP6) then
				xwalk = xwalk + 1
			end
	        
			if xwalk ~= 0 or ywalk ~= 0 then
				--self.inst.components.inventory:DropActiveItem()

				local dir = TheCamera:GetRightVec() * xwalk - TheCamera:GetDownVec() * ywalk
				dir = dir:GetNormalized()
				--local pt = Vector3(self.inst.Transform:GetWorldPosition()) + dir
				--self.inst.components.locomotor:GoToPoint(pt, nil, true)
				local ang = -math.atan2(dir.z, dir.x)/DEGREES
				self.inst.components.locomotor:WalkInDirection(ang, true)
				self.directwalking = true
				self.inst.components.locomotor:SetBufferedAction(nil)
				self.inst:ClearBufferedAction()
				
				if not self.inst.sg:HasStateTag("attack") then
					self.inst.components.combat:SetTarget(nil)
				end
			else
				if self.directwalking then
					self.inst.components.locomotor:Stop()
					self.directwalking = false
				end
			end
		end
    end
    
end




function playercontroller_3:DoAction(buffaction)
	Print(VERBOSITY.DEBUG, "playercontroller_3:DoAction")
    if buffaction then
    
        if self.inst.bufferedaction then
            if self.inst.bufferedaction.action == buffaction.action and self.inst.bufferedaction.target == buffaction.target then
                return;
            end
        end
        
        if buffaction.target and buffaction.target.components.highlight then
            buffaction.target.components.highlight:Flash(.2, .125, .1)
        end
		
		Print(VERBOSITY.DEBUG, "Performing Action: ["..buffaction.action.id.."]")
        if  buffaction.invobject and 
            buffaction.invobject.components.equippable and 
            buffaction.invobject.components.equippable.equipslot == EQUIPSLOTS.HANDS and 
            (buffaction.action ~= ACTIONS.DROP) then
            
                if not buffaction.invobject.components.equippable.isequipped then 
                    self.inst.components.inventory_2:Equip(buffaction.invobject)
                end
                
                if self.inst.components.inventory_2:GetActiveItem() == buffaction.invobject then
                    self.inst.components.inventory_2:SetActiveItem(nil)
                end
        end
        
        self.inst.components.locomotor:PushAction(buffaction, true)
    end    

end





return playercontroller_3
